package 
{
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.ui.Keyboard;
  import flash.utils.Dictionary;



	//[Frame(factoryClass="Preloader")]
	public class Main extends xGame 
	{

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
  
    

    [Embed(source = "minifont8.png")]  private static var embedFontPic8:Class;
    [Embed(source = "minifont8.xfnt", mimeType = "application/octet-stream")]
    private static var embedFont8:Class;
    
    
    [Embed(source = "rocket.png")] private static var embedPicRocket:Class;
    [Embed(source = "asteroid.png")] private static var embedPicAster:Class;
    [Embed(source = "missile.png")] private static var embedPicMissile:Class;
    
    public var dictPic:Dictionary = new Dictionary();
    
    public function getData(wname:String):BitmapData { return dictPic[wname]; }
   
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      stage.quality = "LOW";
 
      myAdvFont = new xAdvFont();
      myAdvFont.loadFont(embedFont8, embedFontPic8);
 
      dictPic["rocket"] = (new embedPicRocket).bitmapData;
      dictPic["asteroid"] = (new embedPicAster).bitmapData;
      dictPic["missile"] = (new embedPicMissile).bitmapData;
      
      
      
      loadMap();

   
      stage.addEventListener(MouseEvent.MOUSE_DOWN, onMdown);
      stage.addEventListener(MouseEvent.MOUSE_UP, onMup);
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKdown);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKup);
      stage.addEventListener(Event.ENTER_FRAME, onEnter);   
		}//init
    
    public var myAdvFont:xAdvFont;
 
    public var vecAct:Vector.<xActor>;
    public function addActor(a:xActor):void    { a.game = this; addActorx(a, vecAct); }      

    public function loadMap():void
    { 
       seed = 0; 
       curId = 1;
       vecAct = new Vector.<xActor>(0, false);   
       mw = 16; mh = 16;   cw = 64; ch = 64;
       gridAct = new Vector.<xActor>(mw * mh, false);
       
       
       
       a = new xPlayer();
        a.cx = 320; a.cy = 240;
        addActor(a);
       
       var i:int; var a:xActor;
       var ta:Number;
       for (i = 0; i < 8; i += 1)
       {
         a = new xAster();
         ta = getRand() * 6.28;
          //a.cx = Math.random() * 640;
          //a.cy = Math.random() * 480;
          a.cx = 320 + Math.cos(ta) * 160;
          a.cy = 240 + Math.sin(ta) * 160;
          a.speed = 0.5;
          a.ang = Math.random() * 6.28;
          a.xrad = a.yrad = 32;
          a.team = 3;
         addActor(a);
         
       }//nexti

      
    }//loadmap




    public function onEnter(e:Event):void
    {  

      mx = stage.mouseX; my = stage.mouseY;
      if (mx < 0) { mx = 0; } if (my < 0) { my = 0; }
      if (mx > 640) { mx = 640; } if (my > 480) { my = 480; }
      wmx = mx; wmy = my;
   

       var i:int; var num:int; var a:xActor;
      
          thinkVec(vecAct, gt);
          updateVec(vecAct);

      
      graphics.clear();
        canvas.fillRect(canvas.rect, 0x808080);
        
          num = vecAct.length;
          for(i=0;i<num;i+=1)
          {
            a = vecAct[i];  
            if (a.skin == null) { continue;  }
            drawSprite2(canvas, a.skin, a.cx, a.cy, a.drawAng, false, false, a.drawScale, a.drawScale);
          }//nexti
        
       // myAdvFont.writeStr(canvas, 16, 16, "" + gt);
        graphics.beginBitmapFill(canvas, null, false, false);
          graphics.drawRect(0, 0, 640, 480);
        graphics.endFill();
      canvas.unlock();
      canvas.lock();
      
    
      
      
       graphics.lineStyle(2, 0);

     /*
        num = vecAct.length;
        for(i=0;i<num;i+=1)
        {
          a = vecAct[i];  
          
          graphics.drawCircle(a.cx, a.cy, a.xrad);
          graphics.drawRect(a.cx - a.xrad, a.cy - a.yrad, a.xrad * 2, a.yrad * 2);
          graphics.moveTo(a.cx, a.cy);
          graphics.lineTo(a.cx + Math.cos(a.ang) * 16, a.cy + Math.sin(a.ang) * 16);
  
        }//nexti
      */
        /*
      var ms:Number;
      graphics.lineStyle(2, 0);
        ms = 8;
        graphics.moveTo(mx, my - ms);
        graphics.lineTo(mx, my + ms);
        graphics.moveTo(mx-ms, my);
        graphics.lineTo(mx+ms, my);
*/

       gt += 1;
       keyTime += 1;
    }//onenter
    
    
   


 
  }//classend
}



