package  
{
  import flash.display.BitmapData;
	
  public class xActor
  {
    public var game:Main = null; public var id:int = -1;
    
    public var next:xActor = null;   public var prev:xActor = null;    
    public var tx:int = -1;    public var ty:int = -1;
    
    
    public var hp:Number = 10;
    public var dead:Boolean = false;
    public var asleep:Boolean = false;
    
    public var flags:int = 0;
    public var specType:int = 0;
    public var team:int = 0;
    public var ownerid:int = 0;
    
    public var cx:Number = 0;  public var cy:Number = 0;  
    public var vx:Number = 0;  public var vy:Number = 0;
    public var xrad:Number = 8; public var yrad:Number = 8;

    public var ang:Number = 0;
    public var wallhit:int = 0;
    
    public var dmg:Number = 0;
    public var dmgTime:int = 0;
    public var reload:int = 0;
    
    public var gx:Number = 0; public var gy:Number = 0;
    public var speed:Number = 2;
    
      public var skin:BitmapData = null;
      public var drawScale:Number = 1.0;   
      public var drawAng:Number = 0;

    public function init():void { }  
    public function think():void {}
    public function update():void {} 
    public function remove():void  { takeOutOfGrid(); }  
    public function handCol(a:xActor):Boolean   { return false; }
    
    public function takeOutOfGrid():void
    { game.gridRemAct(this);   }  

    public function putInGridXY():void
    { game.gridRemAct(this);  game.gridAddAct(cx, cy, this);   }
    
    public function gotHit(d:Number, attid:int = -1, ax:Number = 0, ay:Number = 0):void  
    {
      hp -= d;   dmgTime = game.gt + 4;    vx += ax; vy += ay; 
      if (hp < 0) { kill();  }
    }//gothit

    public function kill():void { if (dead) { return; } dead = true; onKilled(); }
    public function onKilled():void {}

    
    
    
    
     
   public static var FR_NONE:int = 0;
   public static var FR_SHOOTABLE:int = 1;   
   public static var FR_TARGET:int = 2;
   public static var FR_BLOCK:int = 4;
  
   
   public static var ST_NONE:int = 0;
   public static var ST_DOT:int = 1;
    
   
    //uses radians 
    //rotate a to b dy d percent (but not faster than max)
    public static function angLerp(a:Number, b:Number, d:Number=0.1, max:Number=6.28):Number
    {
      var c:Number;    var k:Number;
      if ( (a - b) > 3.1415 )    {  c = b + 6.28;       k = (c - a) * d;
      if (k > max) { k= max;} else { if (k <-max) {k = -max;}}   a += k;    if (a > 6.28) a -= 6.28;    }
      else  {  if ( (a - b) < -3.1415 )  {  c = b - 6.28;  k = (c - a) * d;
      if (k > max) { k= max;} else { if (k <-max) {k = -max;}}   a += k;   if (a < 0) a += 6.28;    }
      else {  k = (b - a) * d;  if (k > max) { k= max;} else { if (k <-max) {k = -max;}}  a += k;  }//endif2
      }//endif
      return a;
    }//anglerp
   
    public static function getAng(dy:Number, dx:Number):Number
    {
     // return Math.atan2(dy, dx);
      if (dy == 0 && dx == 0) { return 0; }
      var a:Number;        a = dx / ((dy<0?-dy:dy)+(dx<0?-dx:dx));
      if (dy < 0) { return (a-1)*1.57075; }        return (1-a)*1.57075;
    }//getang

   public static function angDiff(a:Number, b:Number):Number
   { a -= b;      if (a > 3.14) { a -= 6.28; }      if (a < -3.14) { a += 6.28;}      return a;  }
    
   public static function getMag(ax:Number, ay:Number):Number  { return Math.sqrt(ax * ax + ay * ay); }  
   public static function getMag2(ax:Number, ay:Number):Number  {  return  (ax < 0 ? -ax:ax) + (ay < 0? -ay:ay); } 
   public static function getMag3(ax:Number, ay:Number, az:Number):Number  { return Math.sqrt(ax * ax + ay * ay+ az*az); }  

    

    public function isInside(ax:Number, ay:Number):Boolean
    {
       if (ax < cx - xrad) { return false; } if (ax > cx + xrad) { return false; }
       if (ay < cy - yrad) { return false; } if (ay > cy + yrad) { return false; }
      return true;
    }//isinside
    
    public function handBounce(a:xActor):void
    {
       if (vx > 0 && a.isInside(cx + xrad, cy)) { vx *= -1; wallhit |= 1; }
       else if (vx < 0 && a.isInside(cx - xrad, cy)) { vx *= -1; wallhit |= 1; }
       if (vy > 0 && a.isInside(cx , cy+ yrad)) { vy *= -1; wallhit |= 1; }
       else if (vy < 0 && a.isInside(cx, cy - yrad)) { vy *= -1; wallhit |= 1; }
    }//handbounce   
    
    public function platMove():void
    {
      
        if (vx > 0 && cx > 640) { vx = -vx; wallhit |= 1;}
        else if (vx < 0 && cx < 0) { vx = -vx; wallhit |= 1;}
        if (vy > 0 && cy > 640) { vy = -vy; wallhit |= 1; }
        else if (vy < 0 && cy < 0) { vy = -vy; wallhit |= 1;}
 
          
        cx += vx;  cy += vy;  

    }//platmove  
    

  
  
 

   
  }//xactor 

}